Luogu P3547 [POI2013] CEN-Price List 题解 BFS 广度优先搜索

题目链接:Luogu P3547 POI2013 CEN-Price List

题目描述:

给定一张边权均为a的无向图,现在将所有两点之间最短路为2a的点之间增加一条长度为b的无向边,问到给定点s的单元最短路。

题解:

对于一个点u到s的最短路只有三种情况:

  1. 经过的边边权均为a;
  2. 经过的边边权均为b;
  3. 经过的边边权a与b均有。

我们只需要求出上面三种情况的最短路取最小值即可。

对于情况一只需要进行一次BFS即可求出。

对于情况二我们同样可以通过一次BFS求出:

  1. 我们首先建立两张与原图一样的图,我们将两张图的边权全部记作1这样只需在最后的时候乘以a或者b即可,将这两张图记为g和newG;
  2. 对于本轮BFS的结点u,标记其在g中的相邻结点v已访问;
  3. 通过g遍历与u相邻的结点v,通过newG遍历与v相邻的结点w;若w已经被标记,则说明u与w之间的最短路为1,此时两者之间不存在边长为b的边,不能更新dis;若w并没有被标记,说明u与w之间的最短路距离为2,此时存在边长为b的边,所以进行更新dis[w] = dis[u] + 1,并将w入队,删除v到w的边;
  4. 通过g遍历与u相邻的结点v,标记其为未访问。

上述的过程需要删除v到w的边,可以通过前向星实现(建立双向链表)。该算法与三元环计数类似,时间复杂度为 O ( ( n + m ) m ) O((n + m) \sqrt m) O((n+m)m )。能够删除的原因是:根据BFS可以知道先遍历的点的dis一定小于后遍历的点的距离,如果之前通过v到w的这条边更新过,后续通过这条边的距离一定会更大,因此不需要重复遍历。

对于情况三我们可以发现最多只会经过一条边权为a的边。这是因为,如果我们经过了边权为b的边,那么说明b<2a否则不会更优,那么既然这样,每有两条边权为a的边,则可以进行走一次边权为b的边进行优化,最会只可能剩下一条或者零条边权为a的边,如果将原图的边权改为1求得一次的单元最短路的结果记为dis[u](u与s的最短路),则情况三为: ⌊ d i s u 2 ⌋ ∗ b + d i s u m o d 2 ∗ a \lfloor\frac {disu} 2\rfloor * b + disu\ mod\ 2 * a ⌊2disu⌋∗b+disu mod 2∗a。

代码:LuoguP3547

相关推荐
yi0117 小时前
DAY17: LeetCode 139|单词拆分:从“把单词删掉”到用 DP 记录合法切口
人工智能·笔记·python·算法·leetcode·动态规划
陈希瑞7 小时前
LongCat-2.5-Preview 的web逆向能力实测
人工智能·算法·wasm
tangguofeng8 小时前
基于分治策略的循环赛日程表问题的思路讲解
算法
hnjzsyjyj9 小时前
洛谷 P1339:[USACO09OCT] Heat Wave G ← Bellman-Ford 算法
数据结构·bellman-ford 算法
起个名字费劲死了9 小时前
VisionMaster集成深度学习算法(基础狗)
人工智能·深度学习·算法
lengxuenong9 小时前
枚举例题分析
c++·算法·青少年编程
Navigator_Z9 小时前
LeetCode //C - 1269. Number of Ways to Stay in the Same Place After Some Steps
c语言·算法·leetcode
2601_965742229 小时前
短视频脚本创作方法分享:本地生活类账号的起步思路
大数据·人工智能·算法·ai·新媒体运营·生活
55873生态系统手记9 小时前
读完 55873 资产钱包的技术栈,我重新理解了 "合规钱包" 应该长什么样
算法·架构
旋生万物9 小时前
素数螺旋映射 $z_n=n^{1+i}$ 的角分布统计检验与零模型对比
大数据·前端·人工智能·算法·云原生·螺旋生成论·螺旋相位